diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/examples/reference/bianchi11ax.py ns-3.41/src/wifi/examples/reference/bianchi11ax.py
--- ns-3.40/src/wifi/examples/reference/bianchi11ax.py	2023-09-27 13:30:37.898839700 -0700
+++ ns-3.41/src/wifi/examples/reference/bianchi11ax.py	2024-02-09 14:44:08.573794800 -0800
@@ -16,152 +16,224 @@
 #
 # Authors:  Hao Yin and Sebastien Deronne
 #
-import numpy as np
 import math
 
+import numpy as np
+
 
 def bianchi_ax(data_rate, ack_rate, k, difs):
     # Parameters for 11ax
     nA = np.linspace(5, 50, 10)
     CWmin = 15
     CWmax = 1023
-    L_DATA = 1500 * 8 # data size in bits
-    L_ACK = 14 * 8    # ACK size in bits
-    #B = 1/(CWmin+1)
-    B=0
-    EP = L_DATA/(1-B)
-    T_GI = 800e-9                  # guard interval in seconds
-    T_SYMBOL_ACK = 4e-6            # symbol duration in seconds (for ACK)
-    T_SYMBOL_DATA = 12.8e-6 + T_GI # symbol duration in seconds (for DATA)
-    T_PHY_ACK = 20e-6              # PHY preamble & header duration in seconds (for ACK)
-    T_PHY_DATA = 44e-6             # PHY preamble & header duration in seconds (for DATA)
-    L_SERVICE = 16                 # service field length in bits
-    L_TAIL = 6                     # tail length in bits
-    L_MAC = (30) * 8               # MAC header size in bits
-    L_APP_HDR = 8 * 8              # bits added by the upper layer(s)
+    L_DATA = 1500 * 8  # data size in bits
+    L_ACK = 14 * 8  # ACK size in bits
+    # B = 1/(CWmin+1)
+    B = 0
+    EP = L_DATA / (1 - B)
+    T_GI = 800e-9  # guard interval in seconds
+    T_SYMBOL_ACK = 4e-6  # symbol duration in seconds (for ACK)
+    T_SYMBOL_DATA = 12.8e-6 + T_GI  # symbol duration in seconds (for DATA)
+    T_PHY_ACK = 20e-6  # PHY preamble & header duration in seconds (for ACK)
+    T_PHY_DATA = 44e-6  # PHY preamble & header duration in seconds (for DATA)
+    L_SERVICE = 16  # service field length in bits
+    L_TAIL = 6  # tail length in bits
+    L_MAC = (30) * 8  # MAC header size in bits
+    L_APP_HDR = 8 * 8  # bits added by the upper layer(s)
     T_SIFS = 16e-6
     T_DIFS = 34e-6
     T_SLOT = 9e-6
     delta = 1e-7
 
-    Aggregation_Type = 'A_MPDU'   #A_MPDU or A_MSDU (HYBRID not fully supported)
+    Aggregation_Type = "A_MPDU"  # A_MPDU or A_MSDU (HYBRID not fully supported)
     K_MSDU = 1
     K_MPDU = k
     L_MPDU_HEADER = 4
     L_MSDU_HEADER = 14 * 8
-    if (k <= 1):
-        Aggregation_Type = 'NONE'
+    if k <= 1:
+        Aggregation_Type = "NONE"
 
-    N_DBPS = data_rate * T_SYMBOL_DATA   # number of data bits per OFDM symbol
+    N_DBPS = data_rate * T_SYMBOL_DATA  # number of data bits per OFDM symbol
 
-    if (Aggregation_Type == 'NONE'):
-        N_SYMBOLS = math.ceil((L_SERVICE + (L_MAC + L_DATA + L_APP_HDR) + L_TAIL)/N_DBPS)
+    if Aggregation_Type == "NONE":
+        N_SYMBOLS = math.ceil((L_SERVICE + (L_MAC + L_DATA + L_APP_HDR) + L_TAIL) / N_DBPS)
         T_DATA = T_PHY_DATA + (T_SYMBOL_DATA * N_SYMBOLS)
         K_MPDU = 1
         K_MSDU = 1
 
-    if (Aggregation_Type == 'A_MSDU'):
-        N_SYMBOLS = math.ceil((L_SERVICE + K_MPDU*(L_MAC + L_MPDU_HEADER + K_MSDU*(L_MSDU_HEADER + L_DATA + L_APP_HDR)) + L_TAIL)/N_DBPS)
+    if Aggregation_Type == "A_MSDU":
+        N_SYMBOLS = math.ceil(
+            (
+                L_SERVICE
+                + K_MPDU * (L_MAC + L_MPDU_HEADER + K_MSDU * (L_MSDU_HEADER + L_DATA + L_APP_HDR))
+                + L_TAIL
+            )
+            / N_DBPS
+        )
         T_DATA = T_PHY_DATA + (T_SYMBOL_DATA * N_SYMBOLS)
 
-    if (Aggregation_Type == 'A_MPDU'):
-        N_SYMBOLS = math.ceil((L_SERVICE + K_MPDU*(L_MAC + L_MPDU_HEADER + L_DATA + L_APP_HDR) + L_TAIL)/N_DBPS)
+    if Aggregation_Type == "A_MPDU":
+        N_SYMBOLS = math.ceil(
+            (L_SERVICE + K_MPDU * (L_MAC + L_MPDU_HEADER + L_DATA + L_APP_HDR) + L_TAIL) / N_DBPS
+        )
         T_DATA = T_PHY_DATA + (T_SYMBOL_DATA * N_SYMBOLS)
 
-    #Calculate ACK Duration
-    N_DBPS = ack_rate * T_SYMBOL_ACK   # number of data bits per OFDM symbol
-    N_SYMBOLS = math.ceil((L_SERVICE + L_ACK + L_TAIL)/N_DBPS)
+    # Calculate ACK Duration
+    N_DBPS = ack_rate * T_SYMBOL_ACK  # number of data bits per OFDM symbol
+    N_SYMBOLS = math.ceil((L_SERVICE + L_ACK + L_TAIL) / N_DBPS)
     T_ACK = T_PHY_ACK + (T_SYMBOL_ACK * N_SYMBOLS)
 
     T_s = T_DATA + T_SIFS + T_ACK + T_DIFS
-    if difs == 1: #DIFS
+    if difs == 1:  # DIFS
         T_C = T_DATA + T_DIFS
     else:
         T_s = T_DATA + T_SIFS + T_ACK + T_DIFS + delta
         T_C = T_DATA + T_DIFS + T_SIFS + T_ACK + delta
 
-    T_S = T_s/(1-B) + T_SLOT
+    T_S = T_s / (1 - B) + T_SLOT
 
     S_bianchi = np.zeros(len(nA))
     for j in range(len(nA)):
-        n = nA[j]*1
+        n = nA[j] * 1
         W = CWmin + 1
-        m = math.log2((CWmax + 1)/(CWmin + 1))
+        m = math.log2((CWmax + 1) / (CWmin + 1))
         tau1 = np.linspace(0, 0.1, 100000)
-        p = 1 - np.power((1 - tau1),(n - 1))
-        ps = p*0
+        p = 1 - np.power((1 - tau1), (n - 1))
+        ps = p * 0
 
         for i in range(int(m)):
-            ps = ps + np.power(2*p, i)
+            ps = ps + np.power(2 * p, i)
 
-        taup = 2./(1 + W + p*W*ps)
+        taup = 2.0 / (1 + W + p * W * ps)
         b = np.argmin(np.abs(tau1 - taup))
         tau = taup[b]
 
         Ptr = 1 - math.pow((1 - tau), int(n))
-        Ps = n*tau*math.pow((1 - tau), int(n-1))/Ptr
+        Ps = n * tau * math.pow((1 - tau), int(n - 1)) / Ptr
 
-        S_bianchi[j] = K_MSDU*K_MPDU*Ps*Ptr*EP/((1-Ptr)*T_SLOT+Ptr*Ps*T_S+Ptr*(1-Ps)*T_C)/1e6
+        S_bianchi[j] = (
+            K_MSDU
+            * K_MPDU
+            * Ps
+            * Ptr
+            * EP
+            / ((1 - Ptr) * T_SLOT + Ptr * Ps * T_S + Ptr * (1 - Ps) * T_C)
+            / 1e6
+        )
 
     bianchi_result = S_bianchi
     return bianchi_result
 
+
 def str_result(bianchi_result, mcs, bw):
-    str_bianchi = '    {' + '\"HeMcs{:d}'.format(mcs) + '_{:d}MHz\"'.format(bw) + ', {\n'
-    for  i in range (len(bianchi_result)):
-        str_tmp = '        {' + '{:d}, {:.4f}'.format(5*(i+1), bianchi_result[i]) +'},\n'
-        str_bianchi  = str_bianchi + str_tmp
+    str_bianchi = "    {" + '"HeMcs{:d}'.format(mcs) + '_{:d}MHz"'.format(bw) + ", {\n"
+    for i in range(len(bianchi_result)):
+        str_tmp = "        {" + "{:d}, {:.4f}".format(5 * (i + 1), bianchi_result[i]) + "},\n"
+        str_bianchi = str_bianchi + str_tmp
     str_bianchi = str_bianchi + "    }},\n"
     print(str_bianchi)
     return str_bianchi
 
+
 # Settings for different MCS and mode
-data_rates_20MHz = [8.603e6, 17.206e6, 25.8e6, 34.4e6, 51.5e6, 68.8e6, 77.4e6, 86e6, 103.2e6, 114.7e6, 129e6, 143.4e6]
+data_rates_20MHz = [
+    8.603e6,
+    17.206e6,
+    25.8e6,
+    34.4e6,
+    51.5e6,
+    68.8e6,
+    77.4e6,
+    86e6,
+    103.2e6,
+    114.7e6,
+    129e6,
+    143.4e6,
+]
 ack_rates_20MHz = [6e6, 12e6, 12e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6]
-data_rates_40MHz = [17.2e6, 34.4e6, 51.5e6, 68.8e6, 103.2e6, 137.6e6, 154.9e6, 172.1e6, 206.5e6, 229.4e6, 258.1e6, 286.8e6]
+data_rates_40MHz = [
+    17.2e6,
+    34.4e6,
+    51.5e6,
+    68.8e6,
+    103.2e6,
+    137.6e6,
+    154.9e6,
+    172.1e6,
+    206.5e6,
+    229.4e6,
+    258.1e6,
+    286.8e6,
+]
 ack_rates_40MHz = [6e6, 12e6, 12e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6]
-data_rates_80MHz = [36e6, 72.1e6, 108.1e6, 144.1e6, 216.2e6, 288.2e6, 324.3e6, 360.3e6, 432.4e6, 480.4e6, 540.4e6, 600.5e6]
+data_rates_80MHz = [
+    36e6,
+    72.1e6,
+    108.1e6,
+    144.1e6,
+    216.2e6,
+    288.2e6,
+    324.3e6,
+    360.3e6,
+    432.4e6,
+    480.4e6,
+    540.4e6,
+    600.5e6,
+]
 ack_rates_80MHz = [6e6, 12e6, 12e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6]
-data_rates_160MHz = [72.1e6, 144.1e6, 216.2e6, 288.2e6, 432.4e6, 576.5e6, 648.5e6, 720.6e6, 864.7e6, 960.8e6, 1080.9e6, 1201e6]
+data_rates_160MHz = [
+    72.1e6,
+    144.1e6,
+    216.2e6,
+    288.2e6,
+    432.4e6,
+    576.5e6,
+    648.5e6,
+    720.6e6,
+    864.7e6,
+    960.8e6,
+    1080.9e6,
+    1201e6,
+]
 ack_rates_160MHz = [6e6, 12e6, 12e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6, 24e6]
 
 # Generate results with frame aggregation disabled
 k = 1
 
 difs = 1
-with open("bianchi_11ax_difs.txt", "w", encoding="utf-8") as fo:
+with open("bianchi_11ax_difs.txt", "w", encoding="utf-8") as f:
     for i in range(len(data_rates_20MHz)):
         bianchi_result = bianchi_ax(data_rates_20MHz[i], ack_rates_20MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 20)
-        fo.write(str_s)
+        f.write(str_s)
     for i in range(len(data_rates_40MHz)):
         bianchi_result = bianchi_ax(data_rates_40MHz[i], ack_rates_40MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 40)
-        fo.write(str_s)
+        f.write(str_s)
     for i in range(len(data_rates_80MHz)):
         bianchi_result = bianchi_ax(data_rates_80MHz[i], ack_rates_80MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 80)
-        fo.write(str_s)
+        f.write(str_s)
     for i in range(len(data_rates_160MHz)):
         bianchi_result = bianchi_ax(data_rates_160MHz[i], ack_rates_160MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 160)
-        fo.write(str_s)
+        f.write(str_s)
 
 difs = 0
-with open("bianchi_11ax_eifs.txt", "w", encoding="utf-8") as fo:
+with open("bianchi_11ax_eifs.txt", "w", encoding="utf-8") as f:
     for i in range(len(data_rates_20MHz)):
         bianchi_result = bianchi_ax(data_rates_20MHz[i], ack_rates_20MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 20)
-        fo.write(str_s)
+        f.write(str_s)
     for i in range(len(data_rates_40MHz)):
         bianchi_result = bianchi_ax(data_rates_40MHz[i], ack_rates_40MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 40)
-        fo.write(str_s)
+        f.write(str_s)
     for i in range(len(data_rates_80MHz)):
         bianchi_result = bianchi_ax(data_rates_80MHz[i], ack_rates_80MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 80)
-        fo.write(str_s)
+        f.write(str_s)
     for i in range(len(data_rates_160MHz)):
         bianchi_result = bianchi_ax(data_rates_160MHz[i], ack_rates_160MHz[i], k, difs)
         str_s = str_result(bianchi_result, i, 160)
-        fo.write(str_s)
+        f.write(str_s)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/examples/wifi-manager-example.cc ns-3.41/src/wifi/examples/wifi-manager-example.cc
--- ns-3.40/src/wifi/examples/wifi-manager-example.cc	2023-09-27 13:30:37.898839700 -0700
+++ ns-3.41/src/wifi/examples/wifi-manager-example.cc	2024-02-09 14:44:08.573794800 -0800
@@ -289,14 +289,14 @@
         {
             serverChannelWidth = GetDefaultChannelWidth(WIFI_STANDARD_80211b, WIFI_PHY_BAND_2_4GHZ);
         }
-        NS_ABORT_MSG_IF(serverChannelWidth != 22 && serverChannelWidth != 22,
+        NS_ABORT_MSG_IF(serverChannelWidth != 22,
                         "Invalid channel width for standard " << standard);
         NS_ABORT_MSG_IF(serverNss != 1, "Invalid nss for standard " << standard);
         if (clientChannelWidth == 0)
         {
             clientChannelWidth = GetDefaultChannelWidth(WIFI_STANDARD_80211b, WIFI_PHY_BAND_2_4GHZ);
         }
-        NS_ABORT_MSG_IF(clientChannelWidth != 22 && clientChannelWidth != 22,
+        NS_ABORT_MSG_IF(clientChannelWidth != 22,
                         "Invalid channel width for standard " << standard);
         NS_ABORT_MSG_IF(clientNss != 1, "Invalid nss for standard " << standard);
     }
@@ -635,7 +635,7 @@
     NetDeviceContainer serverDevice;
     NetDeviceContainer clientDevice;
 
-    TupleValue<UintegerValue, UintegerValue, EnumValue, UintegerValue> channelValue;
+    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue> channelValue;
 
     WifiMacHelper wifiMac;
     if (infrastructure)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/examples/wifi-test-interference-helper.cc ns-3.41/src/wifi/examples/wifi-test-interference-helper.cc
--- ns-3.40/src/wifi/examples/wifi-test-interference-helper.cc	2023-09-27 13:30:37.898839700 -0700
+++ ns-3.41/src/wifi/examples/wifi-test-interference-helper.cc	2024-02-09 14:44:08.573794800 -0800
@@ -287,10 +287,10 @@
     devRx->SetPhy(rx);
     nodeRx->AddDevice(devRx);
 
-    m_txA->SetOperatingChannel(WifiPhy::ChannelTuple{input.channelA, 0, (int)(input.band), 0});
-    m_txB->SetOperatingChannel(WifiPhy::ChannelTuple{input.channelB, 0, (int)(input.band), 0});
+    m_txA->SetOperatingChannel(WifiPhy::ChannelTuple{input.channelA, 0, input.band, 0});
+    m_txB->SetOperatingChannel(WifiPhy::ChannelTuple{input.channelB, 0, input.band, 0});
     rx->SetOperatingChannel(
-        WifiPhy::ChannelTuple{std::max(input.channelA, input.channelB), 0, (int)(input.band), 0});
+        WifiPhy::ChannelTuple{std::max(input.channelA, input.channelB), 0, input.band, 0});
 
     rx->TraceConnectWithoutContext("PhyRxDrop",
                                    MakeCallback(&InterferenceExperiment::PacketDropped, this));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/examples/wifi-trans-example.cc ns-3.41/src/wifi/examples/wifi-trans-example.cc
--- ns-3.40/src/wifi/examples/wifi-trans-example.cc	2023-09-27 13:30:37.898839700 -0700
+++ ns-3.41/src/wifi/examples/wifi-trans-example.cc	2024-02-09 14:44:08.573794800 -0800
@@ -269,7 +269,7 @@
     std::vector<double> freqs;
     int margin = 2; // 1MHz margin on each side
     int band = (bw + margin);
-    freqs.reserve((4 * 10 * band));
+    freqs.reserve(4 * 10 * band);
     for (int i = 0; i < (4 * 10 * band); ++i) // conversion to 100kHz scale
     {
         freqs.push_back(i * 1e5 + (freq - 2 * band) * 1e6);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/helper/spectrum-wifi-helper.cc ns-3.41/src/wifi/helper/spectrum-wifi-helper.cc
--- ns-3.40/src/wifi/helper/spectrum-wifi-helper.cc	2023-09-27 13:30:37.898839700 -0700
+++ ns-3.41/src/wifi/helper/spectrum-wifi-helper.cc	2024-02-09 14:44:08.573794800 -0800
@@ -148,7 +148,7 @@
         }
         InstallPhyInterfaces(i, phy);
         phy->SetChannelSwitchedCallback(
-            MakeCallback(&SpectrumWifiPhyHelper::SpectrumChannelSwitched, this).Bind(phy));
+            MakeCallback(&SpectrumWifiPhyHelper::SpectrumChannelSwitched).Bind(phy));
         phy->SetDevice(device);
         phy->SetMobility(node->GetObject<MobilityModel>());
         ret.emplace_back(phy);
@@ -178,9 +178,8 @@
 }
 
 void
-SpectrumWifiPhyHelper::SpectrumChannelSwitched(Ptr<SpectrumWifiPhy> phy) const
+SpectrumWifiPhyHelper::SpectrumChannelSwitched(Ptr<SpectrumWifiPhy> phy)
 {
-    NS_LOG_FUNCTION(this << phy);
     for (const auto& otherPhy : phy->GetDevice()->GetPhys())
     {
         auto spectrumPhy = DynamicCast<SpectrumWifiPhy>(otherPhy);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/helper/spectrum-wifi-helper.h ns-3.41/src/wifi/helper/spectrum-wifi-helper.h
--- ns-3.40/src/wifi/helper/spectrum-wifi-helper.h	2023-09-27 13:30:37.898839700 -0700
+++ ns-3.41/src/wifi/helper/spectrum-wifi-helper.h	2024-02-09 14:44:08.573794800 -0800
@@ -120,12 +120,6 @@
     void InstallPhyInterfaces(uint8_t linkId, Ptr<SpectrumWifiPhy> phy) const;
 
     /**
-     * Function that is notified when a spectrum channel switched
-     * \param phy spectrum PHY instance that has switched its channel
-     */
-    void SpectrumChannelSwitched(Ptr<SpectrumWifiPhy> phy) const;
-
-    /**
      * \param channel The channel to inspect to possibly add a WifiBandwidthFilter
      *
      * This method will add a WifiBandwidthFilter object to the SpectrumChannel, only if
@@ -133,6 +127,12 @@
      */
     void AddWifiBandwidthFilter(Ptr<SpectrumChannel> channel);
 
+    /**
+     * Function that is notified when a spectrum channel switched
+     * \param phy spectrum PHY instance that has switched its channel
+     */
+    static void SpectrumChannelSwitched(Ptr<SpectrumWifiPhy> phy);
+
     std::map<FrequencyRange, Ptr<SpectrumChannel>> m_channels; ///< the spectrum channels
     std::map<uint8_t /* linkId */, std::set<FrequencyRange>>
         m_interfacesMap; ///< map of the spectrum PHY interfaces to be added to the PHY instance
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/helper/wifi-helper.cc ns-3.41/src/wifi/helper/wifi-helper.cc
--- ns-3.40/src/wifi/helper/wifi-helper.cc	2023-09-27 13:30:37.898839700 -0700
+++ ns-3.41/src/wifi/helper/wifi-helper.cc	2024-02-09 14:44:08.573794800 -0800
@@ -992,40 +992,45 @@
     for (auto i = c.Begin(); i != c.End(); ++i)
     {
         netDevice = (*i);
-        Ptr<WifiNetDevice> wifi = DynamicCast<WifiNetDevice>(netDevice);
-        if (wifi)
+        if (auto wifi = DynamicCast<WifiNetDevice>(netDevice))
         {
             // Handle any random numbers in the PHY objects.
-            currentStream += wifi->GetPhy()->AssignStreams(currentStream);
+            for (auto& phy : wifi->GetPhys())
+            {
+                currentStream += phy->AssignStreams(currentStream);
+            }
 
             // Handle any random numbers in the station managers.
-            currentStream += wifi->GetRemoteStationManager()->AssignStreams(currentStream);
+            for (auto& manager : wifi->GetRemoteStationManagers())
+            {
+                currentStream += manager->AssignStreams(currentStream);
+            }
 
             // Handle any random numbers in the MAC objects.
-            Ptr<WifiMac> mac = wifi->GetMac();
+            auto mac = wifi->GetMac();
             PointerValue ptr;
             if (!mac->GetQosSupported())
             {
                 mac->GetAttribute("Txop", ptr);
-                Ptr<Txop> txop = ptr.Get<Txop>();
+                auto txop = ptr.Get<Txop>();
                 currentStream += txop->AssignStreams(currentStream);
             }
             else
             {
                 mac->GetAttribute("VO_Txop", ptr);
-                Ptr<QosTxop> vo_txop = ptr.Get<QosTxop>();
+                auto vo_txop = ptr.Get<QosTxop>();
                 currentStream += vo_txop->AssignStreams(currentStream);
 
                 mac->GetAttribute("VI_Txop", ptr);
-                Ptr<QosTxop> vi_txop = ptr.Get<QosTxop>();
+                auto vi_txop = ptr.Get<QosTxop>();
                 currentStream += vi_txop->AssignStreams(currentStream);
 
                 mac->GetAttribute("BE_Txop", ptr);
-                Ptr<QosTxop> be_txop = ptr.Get<QosTxop>();
+                auto be_txop = ptr.Get<QosTxop>();
                 currentStream += be_txop->AssignStreams(currentStream);
 
                 mac->GetAttribute("BK_Txop", ptr);
-                Ptr<QosTxop> bk_txop = ptr.Get<QosTxop>();
+                auto bk_txop = ptr.Get<QosTxop>();
                 currentStream += bk_txop->AssignStreams(currentStream);
             }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/addba-extension.cc ns-3.41/src/wifi/model/addba-extension.cc
--- ns-3.40/src/wifi/model/addba-extension.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/src/wifi/model/addba-extension.cc	2024-02-09 14:44:08.577794800 -0800
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "addba-extension.h"
+
+namespace ns3
+{
+
+void
+AddbaExtension::Print(std::ostream& os) const
+{
+    os << "extBufferSize=" << +m_extParamSet.extBufferSize;
+}
+
+WifiInformationElementId
+AddbaExtension::ElementId() const
+{
+    return IE_ADDBA_EXTENSION;
+}
+
+uint16_t
+AddbaExtension::GetInformationFieldSize() const
+{
+    return 1U; // ADDBA Extended Parameter Set field
+}
+
+void
+AddbaExtension::SerializeInformationField(Buffer::Iterator start) const
+{
+    uint8_t extParamSet = m_extParamSet.noFragment | (m_extParamSet.heFragmentOp << 1) |
+                          (m_extParamSet.extBufferSize << 5);
+    start.WriteU8(extParamSet);
+}
+
+uint16_t
+AddbaExtension::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
+{
+    auto extParamSet = start.ReadU8();
+    m_extParamSet.noFragment = extParamSet & 0x01;
+    m_extParamSet.heFragmentOp = (extParamSet >> 1) & 0x03;
+    m_extParamSet.extBufferSize = (extParamSet >> 5) & 0x07;
+    return 1;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/addba-extension.h ns-3.41/src/wifi/model/addba-extension.h
--- ns-3.40/src/wifi/model/addba-extension.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/src/wifi/model/addba-extension.h	2024-02-09 14:44:08.577794800 -0800
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef ADDBA_EXTENSION_H
+#define ADDBA_EXTENSION_H
+
+#include "wifi-information-element.h"
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ *
+ * The IEEE 802.11 ADDBA Extension Element (Sec. 9.4.2.139 of 802.11-2020)
+ */
+class AddbaExtension : public WifiInformationElement
+{
+  public:
+    AddbaExtension() = default;
+
+    /**
+     * ADDBA Extended Parameter Set
+     */
+    struct ExtParamSet
+    {
+        uint8_t noFragment : 1;    //!< reserved when transmitted by HE STA to HE STA
+        uint8_t heFragmentOp : 2;  //!< indicates level of HE dynamic fragmentation (unsupported)
+        uint8_t : 2;               //!< reserved
+        uint8_t extBufferSize : 3; //!< extended buffer size
+    };
+
+    // Implementations of pure virtual methods of WifiInformationElement
+    WifiInformationElementId ElementId() const override;
+    void Print(std::ostream& os) const override;
+
+    ExtParamSet m_extParamSet{}; //!< ADDBA Extended Parameter Set field
+
+  private:
+    uint16_t GetInformationFieldSize() const override;
+    void SerializeInformationField(Buffer::Iterator start) const override;
+    uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+};
+
+} // namespace ns3
+
+#endif /* ADDBA_EXTENSION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/ap-wifi-mac.cc ns-3.41/src/wifi/model/ap-wifi-mac.cc
--- ns-3.40/src/wifi/model/ap-wifi-mac.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/ap-wifi-mac.cc	2024-02-09 14:44:08.577794800 -0800
@@ -25,6 +25,7 @@
 #include "channel-access-manager.h"
 #include "mac-rx-middle.h"
 #include "mac-tx-middle.h"
+#include "mgt-action-headers.h"
 #include "mgt-headers.h"
 #include "msdu-aggregator.h"
 #include "qos-txop.h"
@@ -684,6 +685,26 @@
         TimeValue time;
         ehtConfiguration->GetAttribute("TransitionTimeout", time);
         mle.SetTransitionTimeout(time.Get());
+
+        // An AP affiliated with an AP MLD may include the Medium Synchronization Delay Information
+        // subfield in the Common Info field of the Basic Multi-Link element carried in transmitted
+        // (Re)Association Response or Multi-Link Probe Response frames to provide medium
+        // synchronization information used by the AP MLD. (Section 35.3.16.8.2 of 802.11be D3.1)
+        if (frameType == WIFI_MAC_MGT_ASSOCIATION_RESPONSE)
+        {
+            auto& commonInfo = mle.GetCommonInfoBasic();
+
+            ehtConfiguration->GetAttribute("MediumSyncDuration", time);
+            commonInfo.SetMediumSyncDelayTimer(time.Get());
+
+            IntegerValue ofdmEdThres;
+            ehtConfiguration->GetAttribute("MsdOfdmEdThreshold", ofdmEdThres);
+            commonInfo.SetMediumSyncOfdmEdThreshold(ofdmEdThres.Get());
+
+            UintegerValue maxNTxops;
+            ehtConfiguration->GetAttribute("MsdMaxNTxops", maxNTxops);
+            commonInfo.SetMediumSyncMaxNTxops(maxNTxops.Get());
+        }
     }
 
     // The MLD Capabilities And Operations subfield is present in the Common Info field of the
@@ -698,7 +719,7 @@
         mldCapabilities.emplace();
         mldCapabilities->maxNSimultaneousLinks = GetNLinks() - 1; // assuming STR for now
         mldCapabilities->srsSupport = 0;
-        EnumValue negSupport;
+        EnumValue<WifiTidToLinkMappingNegSupport> negSupport;
         ehtConfiguration->GetAttributeFailSafe("TidToLinkMappingNegSupport", negSupport);
         mldCapabilities->tidToLinkMappingSupport = negSupport.Get();
         mldCapabilities->freqSepForStrApMld = 0; // not supported yet
@@ -1957,7 +1978,7 @@
                     return failure("Incorrect directions in TID-to-Link Mapping IEs");
                 }
 
-                EnumValue negSupport;
+                EnumValue<WifiTidToLinkMappingNegSupport> negSupport;
                 ehtConfig->GetAttributeFailSafe("TidToLinkMappingNegSupport", negSupport);
 
                 if (negSupport.Get() == 0)
@@ -2191,7 +2212,7 @@
     // completed. For this purpose, we connect a callback to the PHY TX begin trace to catch
     // the Ack transmitted after the EML Notification frame.
     CallbackBase cb = Callback<void, WifiConstPsduMap, WifiTxVector, double>(
-        [=](WifiConstPsduMap psduMap, WifiTxVector txVector, double /* txPowerW */) {
+        [=, this](WifiConstPsduMap psduMap, WifiTxVector txVector, double /* txPowerW */) {
             NS_ASSERT_MSG(psduMap.size() == 1 && psduMap.begin()->second->GetNMpdus() == 1 &&
                               psduMap.begin()->second->GetHeader(0).IsAck(),
                           "Expected a Normal Ack after EML Notification frame");
@@ -2203,7 +2224,7 @@
             ehtConfiguration->GetAttribute("TransitionTimeout", transitionTimeout);
 
             m_transitionTimeoutEvents[sender] =
-                Simulator::Schedule(ackDuration + transitionTimeout.Get(), [=]() {
+                Simulator::Schedule(ackDuration + transitionTimeout.Get(), [=, this]() {
                     for (uint8_t id = 0; id < GetNLinks(); id++)
                     {
                         auto linkAddress =
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/block-ack-agreement.cc ns-3.41/src/wifi/model/block-ack-agreement.cc
--- ns-3.40/src/wifi/model/block-ack-agreement.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/block-ack-agreement.cc	2024-02-09 14:44:08.577794800 -0800
@@ -23,6 +23,8 @@
 
 #include "ns3/log.h"
 
+#include <set>
+
 namespace ns3
 {
 
@@ -49,8 +51,6 @@
 BlockAckAgreement::SetBufferSize(uint16_t bufferSize)
 {
     NS_LOG_FUNCTION(this << bufferSize);
-    NS_ASSERT(bufferSize <= 256);
-    NS_ASSERT(bufferSize % 16 == 0);
     m_bufferSize = bufferSize;
 }
 
@@ -174,12 +174,13 @@
     {
         return BlockAckType::BASIC;
     }
+
+    std::set<uint16_t> lengths{64, 256, 512, 1024}; // bitmap lengths in bits
+    // first bitmap length that is greater than or equal to the buffer size
+    auto it = lengths.lower_bound(m_bufferSize);
+    NS_ASSERT_MSG(it != lengths.cend(), "Buffer size too large: " << m_bufferSize);
     // Multi-TID Block Ack is not currently supported
-    if (m_bufferSize > 64)
-    {
-        return {BlockAckType::COMPRESSED, {32}};
-    }
-    return {BlockAckType::COMPRESSED, {8}};
+    return {BlockAckType::COMPRESSED, {static_cast<uint8_t>(*it / 8)}};
 }
 
 BlockAckReqType
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/block-ack-manager.cc ns-3.41/src/wifi/model/block-ack-manager.cc
--- ns-3.40/src/wifi/model/block-ack-manager.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/block-ack-manager.cc	2024-02-09 14:44:08.577794800 -0800
@@ -21,7 +21,7 @@
 
 #include "ctrl-headers.h"
 #include "mac-rx-middle.h"
-#include "mgt-headers.h"
+#include "mgt-action-headers.h"
 #include "qos-utils.h"
 #include "wifi-mac-queue.h"
 #include "wifi-tx-vector.h"
@@ -756,6 +756,7 @@
                                    OriginatorBlockAckAgreement::REJECTED);
     }
     it->second.first.SetState(OriginatorBlockAckAgreement::REJECTED);
+    m_unblockPackets(recipient, tid);
 }
 
 void
